;********************************************************************************************
;********************************************************************************************
;
;	ROUTINE MATEMATICHE SPECIFICHE PER "PIC18FXXX"
;	Versione 1.3		     Ult.agg. 15/01/04
;
;********************************************************************************************
;********************************************************************************************
;
;	DEFINIZIONE DELLE ROUTINE UTILIZZATE PER IL PROGRAMMA
;	PER UTILIZZARE UNA ROUTINE MATEMATICA BASTA DEFINIRE 
;	LA CORRISPONDENTE <ROUTINE>_DEF, E PER UTILIZZARLA BASTA
;	LA LABEL CORRISPONDENTE <ROUTINE>
;
;********************************************************************************************
;

#DEFINE	SGN_CALC_DEF		; Primitiva

#DEFINE	FXM1616U_DEF		; Primitiva

#DEFINE	FXM2424U_DEF		; Primitiva

#DEFINE	FXD1616U_DEF		; Primitiva

#DEFINE	FXD2424U_DEF		; Primitiva

#DEFINE	FXD3232U_DEF		; Primitiva

#DEFINE	FXD0808U_DEF		; Primitiva

#DEFINE	ADD_SUB_16_DEF		; Primitiva

#DEFINE ADD_SUB_24_DEF		; Primitiva

#DEFINE ADD_SUB_32_DEF		; Primitiva

#DEFINE AGEBRIC_SUM_16_DEF	; Richiede "ADD_SUB_16_DEF"

#DEFINE AGEBRIC_SUM_24_DEF	; Richiede "ADD_SUB_24_DEF" ... RIGUARDARE ...

#DEFINE AGEBRIC_SUM_32_DEF	; Richiede "ADD_SUB_32_DEF"

#DEFINE DECIMAL_DECODE_5CIF_DEF	; Richiede "FXM1616U_DEF"

#UNDEFINE DECIMAL_DECODE_BYTE_DEF	; Richiede "FXM0808U_DEF"

;
; INOLTRE E' DEFINITA LA MACRO "MUL_AXB" CON CUI SI FA' DIRETTAMENTE IL PRODOTTO
; TRA DUE REGISTRI
;
;********************************************************************************************
;********************************************************************************************
;********************************************************************************************



;********************************************************************************************
;
;	DEFINIZIONE REGISTRI PER OERAZIONI MATEMATICHE
;
;********************************************************************************************

	#define	_C		STATUS,0
	#define	_Z		STATUS,2

	#define	RLF		RLCF	;; SOLO PER I 18Fxxx
	#define	RRF		RRCF	;; SOLO PER I 18Fxxx


B0	equ	0
B1	equ	1
B2	equ	2
B3	equ	3
B4	equ	4
B5	equ	5
B6	equ	6
B7	equ	7

MSB	equ	7
LSB	equ	0

A_SGN		EQU	0
B_SGN		EQU	1
OVER_FL		EQU	2

	#define	OVERFLOW	SEGNO, OVER_FL	; SOLO PER COMODITA'
	#define	SEGNO_A		SEGNO, A_SGN	; 1 == + ; SOLO PER COMODITA'
	#define	SEGNO_B		SEGNO, B_SGN	; 1 == + ; SOLO PER COMODITA'



CBLOCK 0x00

	AARGB0, AARGB1, AARGB2, AARGB3, AARGB4, AARGB5
	BARGB0, BARGB1, BARGB2, BARGB3, BARGB4, BARGB5
	REMB3, REMB2, REMB1, REMB0, LOOPCOUNT, TEMPB0, TEMPB1, TEMPB2
	UNIT, DEC, CENT, MIGL, DECMIGL, SEGNO

ENDC	; SONO D'26' REGISTRI ... IL PRIMO LIBERO E' ALLA LOCAZIONE 0x1A

;-----------------------------------------------------------------------;
;									;
;	AARGB0		AARGB1		AARGB2		AARGB3		;
;	<---------------------------------------------------->		;
;	MSB						   lsb		;
;									;
;	RES3		RES2		RES1		RES0		;
;	<---------------------------------------------------->		;
;	MSB						   lsb		;
;-----------------------------------------------------------------------;

RES0	EQU	REMB0
RES1	EQU	REMB1
RES2	EQU	TEMPB0
RES3	EQU	TEMPB1

ARG1L	EQU	AARGB1
ARG1H	EQU	AARGB0
ARG2L	EQU	BARGB1
ARG2H	EQU	BARGB0

;********************************************************************************************
;********************************************************************************************
;
;	TUTTE LE ROUTINE DI MOLTIPLICAZIONE E DIVISIONE SONO PER INTERI POSITIVI
;	PER IMPLEMENTARE LE OPERAZIONI SEGNATE BASTA UTILIZZARE LA ROUTINE: 
;	"SGN_CALC" CHE DATI I SEGNI DEI DUE ARGOMENTI CALCOLA IL SEGNO DEL RISULTATO
;
;	SEGNO_A      neg_xor   SEGNO_B     --->    SEGNO_A
;    (SEGNO, A_SGN)	    (SEGNO, B_SGN)      (SEGNO, A_SGN)
;
;********************************************************************************************
;				;
IFDEF	SGN_CALC_DEF		;;;;;
				;
SGN_CALC			;
	BTFSS	SEGNO_B		;
	BTG	SEGNO_A		;
	RETURN			;
ENDIF				;;;;;
;				;	
;********************************************************************************************
;********************************************************************************************



;********************************************************************************************
;********************************************************************************************
;
;	MACRO PER FARE LA MOLTIPLICAZIONE 8X8 TRA DUE REGISTRI 
;	SI USA:  "MUL_AXB <REGISTRO_A>, <REGISTRO_B>"
;
;	Timing:     2 clks
;	PM: 2
;	Il risultato  nei registri "PROD_H/L"
;
;--------------------------------------------------------------------------------------------
;						;
						;
MUL_AXB		MACRO	ARGMULA, ARGMULB	;
		MOVF	ARGMULA, W		;
		MULWF	ARGMULB			;
		ENDM				;
;						;
;--------------------------------------------------------------------------------------------
;
;	MACRO PER FARE LA COMPARAZIOE A 16 BIT TRA DUE REGISTRI ...
;	SI USA:  "COMP_MAG <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;	SI USA:  "COMP_MIN <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;	SI USA:  "COMP_EQU <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;
;	SI USA:  "COMP_N_MAG <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;	SI USA:  "COMP_N_MIN <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;	SI USA:  "COMP_N_EQU <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;
;	... E TRA UN REGISTRO E UNA WORD
;	SI USA:  "COMPW_MAG <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;	SI USA:  "COMPW_MIN <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;	SI USA:  "COMPW_EQU <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;
;	SI USA:  "COMPW_N_MAG <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;	SI USA:  "COMPW_N_MIN <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;	SI USA:  "COMPW_N_EQU <REGISTRO_A_H>, <REGISTRO_A_L>, <REGISTRO_B_H>, <REGISTRO_B_L>"
;
;--------------------------------------------------------------------------------------------
;									;

COMP_MAG	MACRO	COMPA_H, COMPA_L, COMPB_H, COMPB_L		; SKIPPA SE A > B
		MOVF	COMPB_H, W					;
		CPFSGT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'12'						;
		CPFSLT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'8'						;
		MOVF	COMPB_L, W					;
		CPFSLT	COMPA_L,					;
		BRA $+D'4'						;(SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;

COMP_MIN	MACRO	COMPA_H, COMPA_L, COMPB_H, COMPB_L		; SKIPPA SE A < B
		MOVF	COMPB_H, W					;
		CPFSLT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'12'						;
		CPFSGT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'8'						;
		MOVF	COMPB_L, W					;
		CPFSGT	COMPA_L,					;
		BRA $+D'4'						;(SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;

COMP_EQU	MACRO	COMPA_H, COMPA_L, COMPB_H, COMPB_L		; SKIPPA SE A = B
		MOVF	COMPB_H, W					;
		CPFSEQ	COMPA_H,					;
		BRA	$+D'10'						;
		MOVF	COMPB_L, W					;
		CPFSEQ	COMPA_L,					;
		BRA $+D'4'						;
		BRA $+D'4'						;(SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;

COMP_N_MAG	MACRO	COMPA_H, COMPA_L, COMPB_H, COMPB_L		; NON SKIPPA SE A > B
		MOVF	COMPB_H, W					;
		CPFSGT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'12'						;
		CPFSLT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'8'						;
		MOVF	COMPB_L, W					;
		CPFSLT	COMPA_L,					;
		BRA $+D'4'						;(NON SKIPPA ISTRUZIONE SUCCESSIVA)
		BRA $+D'4'						;(NON SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;

COMP_N_MIN	MACRO	COMPA_H, COMPA_L, COMPB_H, COMPB_L		; NON SKIPPA SE A > B
		MOVF	COMPB_H, W					;
		CPFSLT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'12'						;
		CPFSGT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'8'						;
		MOVF	COMPB_L, W					;
		CPFSGT	COMPA_L,					;
		BRA $+D'4'						;(NON SKIPPA ISTRUZIONE SUCCESSIVA)
		BRA $+D'4'						;(NON SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;


COMP_N_EQU	MACRO	COMPA_H, COMPA_L, COMPB_H, COMPB_L		; NON SKIPPA SE A = B
		MOVF	COMPB_H, W					;
		CPFSEQ	COMPA_H,					;
		BRA	$+D'6'						;
		MOVF	COMPB_L, W					;
		CPFSEQ	COMPA_L,					;
		BRA $+D'4'						;(SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;
;									;
;									;
COMPW_MAG	MACRO	COMPA_H, COMPA_L, COMPW_H, COMPW_L		; SKIPPA SE A > W
		MOVLW	COMPW_H						;
		CPFSGT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'12'						;
		CPFSLT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'8'						;
		MOVLW	COMPW_L						;
		CPFSLT	COMPA_L,					;
		BRA $+D'4'							;(SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;

COMPW_MIN	MACRO	COMPA_H, COMPA_L, COMPW_H, COMPW_L		; SKIPPA SE A < W
		MOVLW	COMPW_H						;
		CPFSLT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'12'						;
		CPFSGT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'8'						;
		MOVLW	COMPW_L						;
		CPFSGT	COMPA_L,					;
		BRA $+D'4'						;(SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;

COMPW_EQU	MACRO	COMPA_H, COMPA_L, COMPW_H, COMPW_L		; SKIPPA SE A = W
		MOVLW	COMPW_H						;
		CPFSEQ	COMPA_H,					;
		BRA	$+D'10'						;
		MOVLW	COMPW_L						;
		CPFSEQ	COMPA_L,					;
		BRA $+D'4'						;
		BRA $+D'4'						;(SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;

COMPW_N_MAG	MACRO	COMPA_H, COMPA_L, COMPW_H, COMPW_L		; NON SKIPPA SE A > W
		MOVLW	COMPW_H						;
		CPFSGT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'12'						;
		CPFSLT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'8'						;
		MOVLW	COMPW_L						;
		CPFSLT	COMPA_L,					;
		BRA $+D'4'						;(NON SKIPPA ISTRUZIONE SUCCESSIVA)
		BRA $+D'4'						;
		ENDM							;

COMPW_N_MIN	MACRO	COMPA_H, COMPA_L, COMPW_H, COMPW_L		; NON SKIPPA SE A < W
		MOVLW	COMPW_H						;
		CPFSLT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'12'						;
		CPFSGT	COMPA_H,					;
		BRA	$+D'4'						;
		BRA	$+D'8'						;
		MOVLW	COMPW_L						;
		CPFSGT	COMPA_L,					;
		BRA $+D'4'						;(SKIPPA ISTRUZIONE SUCCESSIVA)
		BRA $+D'4'						;
		ENDM							;

COMPW_N_EQU	MACRO	COMPA_H, COMPA_L, COMPW_H, COMPW_L		; NON SKIPPA SE A = W
		MOVLW	COMPW_H						;
		CPFSEQ	COMPA_H,					;
		BRA	$+D'6'						;
		MOVLW	COMPW_L						;
		CPFSEQ	COMPA_L,					;
		BRA $+D'4'						;(SKIPPA ISTRUZIONE SUCCESSIVA)
		ENDM							;
;									;
;********************************************************************************************
;********************************************************************************************





;********************************************************************************************
;********************************************************************************************
;
;	ROUTINE DI MOLTIPLICAZIONE 16X16  
;	
;       16x16 Bit Unsigned Fixed Point Multiply 16x16 -> 32
;       Input:  16 bit unsigned fixed point multiplicand in ARG1H(L)
;            	16 bit unsigned fixed point multiplier in ARG2H(L)
;       Use:    CALL    FXM1616U
;       Output: 32 bit unsigned fixed point product in ....
;       Result: RES  <--  ARG1 x ARG2
;       Timing:     24 clks + CALL and RETURN 
;       PM: 24 + RETURN		DM: 8
;********************************************************************************************
;				;
IFDEF	FXM1616U_DEF		;;;;;
				;
FXM1616U			;
	MOVF 	ARG1L, W	;
	MULWF 	ARG2L 		; ARG1L * ARG2L -> PRODH:PRODL
	MOVFF 	PRODH, RES1 	;
	MOVFF 	PRODL, RES0 	;
				;
	MOVF	ARG1H, W	;
	MULWF	ARG2H		; ARG1H * ARG2H -> PRODH:PRODL
	MOVFF 	PRODH, RES3	;
	MOVFF	PRODL, RES2	;
				;
	MOVF	ARG1L, W	;
	MULWF	ARG2H		; ARG1L * ARG2H -> PRODH:PRODL
	MOVF	PRODL, W	;
	ADDWF	RES1, F		; Add cross
	MOVF	PRODH, W	; products
	ADDWFC	RES2, F		;
	CLRF	WREG		;
	ADDWFC	RES3, F		;
				;
	MOVF	ARG1H, W	;
	MULWF	ARG2L		; ARG1H * ARG2L -> PRODH:PRODL
	MOVF	PRODL, W	;
	ADDWF	RES1, F		; Add cross
	MOVF	PRODH, W	; products
	ADDWFC	RES2, F		;
	CLRF	WREG		;
	ADDWFC	RES3, F		;
	RETURN			;
ENDIF				;;;;
;				;
;********************************************************************************************


;**********************************************************************************************
;**********************************************************************************************
;
;       24x24 Bit Unsigned Fixed Point Multiply 24 x 24 -> 48
;       Input:  24 bit unsigned fixed point multiplicand in AARGB0, AARGB1,
;               AARGB2
;               24 bit unsigned fixed point multiplier in BARGB0, BARGB1,
;               BARGB2
;       Use:    CALL    FXM2424U
;       Output: 48 bit unsigned fixed point product in AARGB0, AARGB1, 
;               AARGB2, AARGB3, AARGB4, AARGB5
;       Result: AARG  <--  AARG * BARG
;       Max Timing:     65 clks
;       Min Timing:     65 clks
;       PM: 64              DM: 12

IFDEF	FXM2424U_DEF
FXM2424U
		MOVFF	AARGB0,TEMPB0	
		MOVFF	AARGB1,TEMPB1	
		MOVFF	AARGB2,TEMPB2	

		MOVF	AARGB2,W
		MULWF	BARGB2
		MOVFF	PRODH,AARGB4
		MOVFF	PRODL,AARGB5
		
		MOVF	AARGB1,W
		MULWF	BARGB1
		MOVFF	PRODH,AARGB2
		MOVFF	PRODL,AARGB3

		MULWF	BARGB2
		MOVF	PRODL,W
		ADDWF	AARGB4,F
		MOVF	PRODH,W
		ADDWFC	AARGB3,F
		CLRF	WREG
		ADDWFC	AARGB2,F

		MOVF	TEMPB2,W
		MULWF	BARGB1
		MOVF	PRODL,W
		ADDWF	AARGB4,F
		MOVF	PRODH,W
		ADDWFC	AARGB3,F
		CLRF	WREG
		ADDWFC	AARGB2,F
	
		MOVF	AARGB0,W
		MULWF	BARGB2
		MOVF	PRODL,W
		ADDWF	AARGB3,F
		MOVF	PRODH,W
		ADDWFC	AARGB2,F
		MOVF	AARGB0,W
		MULWF	BARGB1
		CLRF	AARGB1
		CLRF	WREG
		ADDWFC	AARGB1,F
		MOVF	PRODL,W
		ADDWF	AARGB2,F
		MOVF	PRODH,W
		ADDWFC	AARGB1,F

		MOVF	TEMPB2,W
		MULWF	BARGB0
		MOVF	PRODL,W
		ADDWF	AARGB3,F
		MOVF	PRODH,W
		ADDWFC	AARGB2,F
		CLRF	AARGB0
		CLRF	WREG
		ADDWFC	AARGB1,F
		ADDWFC	AARGB0,F

		MOVF	TEMPB1,W
		MULWF	BARGB0
		MOVF	PRODL,W
		ADDWF	AARGB2,F
		MOVF	PRODH,W
		ADDWFC	AARGB1,F
		CLRF	WREG
		ADDWFC	AARGB0,F

		MOVF	TEMPB0,W
		MULWF	BARGB0
		MOVF	PRODL,W
		ADDWF	AARGB1,F
		MOVF	PRODH,W
		ADDWFC	AARGB0,F

		RETLW	0x00
ENDIF
;
;********************************************************************************************


;********************************************************************************************
;********************************************************************************************
;
;	DIVISIONE 16/16 
;      (QUESTE ROUTINE DI DIVISIONE SONO DA RIADATTARE AL CORE 18FXXX)
;
;********************************************************************************************
;********************************************************************************************

UDIV1616L       macro

;       restore = 23 clks,  nonrestore = 17 clks
;       Max Timing:     2+15*23+22 = 369 clks
;       Min Timing:     2+15*17+16 = 273 clks
;       PM: 24                                  DM: 7

                MOVLW           D'16'
                MOVWF           LOOPCOUNT
LOOPU1616       RLF             AARGB0,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                BTFSS           _C
                INCFSZ          BARGB0,W
                SUBWF           REMB0, F
                BTFSC           _C
                GOTO            UOK66LL         
                MOVF            BARGB1,W
                ADDWF           REMB1, F
                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           REMB0, F
                BCF             _C
UOK66LL		RLF             AARGB1, F
                RLF             AARGB0, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU1616

                endm     

;**********************************************************************************************
;        
;       16/16 Bit Unsigned Fixed Point Divide 16/16 -> 16.16
;
;       Input:  16 bit unsigned fixed point dividend in AARGB0, AARGB1
;               16 bit unsigned fixed point divisor in BARGB0, BARGB1
;
;       Use:    CALL    FXD1616U
;
;       Output: 16 bit unsigned fixed point quotient in AARGB0, AARGB1
;               16 bit unsigned fixed point remainder in REMB0, REMB1
;       Result: AARG, REM  <--  AARG / BARG
;       Max Timing:     2+369+2 = 373 clks
;       Min Timing:     2+273+2 = 277 clks
;       PM: 2+24+1 = 27         DM: 7

IFDEF	FXD1616U_DEF

FXD1616U        CLRF            REMB0
                CLRF            REMB1

                UDIV1616L

                RETLW           0x00   
ENDIF
;
;********************************************************************************************
;********************************************************************************************
;********************************************************************************************




;********************************************************************************************
;********************************************************************************************
;
;	DIVISIONE 8/8
;      (QUESTE ROUTINE DI DIVISIONE SONO DA RIADATTARE AL CORE 18FXXX)
;
;**********************************************************************************************
;**********************************************************************************************

UDIV0808L  macro

;       Max Timing: 2+7*12+11 = 97 clks
;       Min Timing: 2+7*11+10 = 89 clks
;       PM: 13                                  DM: 4

                MOVLW           8
                MOVWF           LOOPCOUNT
LOOPU0808A      RLF             AARGB0,W
                RLF             REMB0, F
                MOVF            BARGB0,W
                SUBWF           REMB0, F
                BTFSC           _C
                GOTO            UOK88A          
                ADDWF           REMB0, F
                BCF             _C
UOK88A          RLF             AARGB0, F
                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU0808A

                endm

;**********************************************************************************************
;        
;       8/8 Bit Unsigned Fixed Point Divide 8/8 -> 08.08
;
;       Input:  8 bit unsigned fixed point dividend in AARGB0
;               8 bit unsigned fixed point divisor in BARGB0
;
;       Use:    CALL    FXD0808U
;       Output: 8 bit unsigned fixed point quotient in AARGB0
;               8 bit unsigned fixed point remainder in REMB0
;       Result: AARG, REM  <--  AARG / BARG
;       Max Timing:     1+97+2 = 100 clks
;       Min Timing:     1+89+2 = 92 clks
;       PM: 1+13+1 = 15         DM: 4

IFDEF	FXD0808U_DEF

FXD0808U        CLRF            REMB0

                UDIV0808L

                RETLW           0x00
ENDIF
;
;**********************************************************************************************
;**********************************************************************************************
;**********************************************************************************************

;********************************************************************************************
;********************************************************************************************
;
;	DIVISIONE 24/24 
;      (ROUTINE SPECIFICHE 18FXXX)
;
;	MAX: 706 CICLI
;********************************************************************************************
;********************************************************************************************
IFDEF FXD2424U_DEF
FXD2424U
    ;// use LOOPCOUNT for the counter...

        ;// Clear the remainder
        clrf REMB0, 0
        clrf REMB1, 0
        clrf REMB2, 0

        ;// Set the counter to 24
        movlw D'24'
        movwf LOOPCOUNT, 0

        ;// Clear the carry flag
        bcf STATUS, 0, 0

loop2424:
	    ;//AARG24 <<= 1; The carry is always clear at the top of the loop.
	    rlcf AARGB2, 1, 0
	    rlcf AARGB1, 1, 0
	    rlcf AARGB0, 1, 0

        ;// REM24 = (REM24 << 1) | (AARG24 >> 24)
	    rlcf REMB2, 1, 0
	    rlcf REMB1, 1, 0
	    rlcf REMB0, 1, 0

        ;//if (PROD >= BARG24)
	    movf BARGB2, 0, 0
	    subwf REMB2, 0, 0
	    movf BARGB1, 0, 0
	    subwfb REMB1, 0, 0
	    movf BARGB0, 0, 0
	    subwfb REMB0, 0, 0
	    bnc _false2424
        ;//{
	        ;//REM24-= BARG24;
	        movf BARGB2, 0, 0
	        subwf REMB2, 1, 0
	        movf BARGB1, 0, 0
	        subwfb REMB1, 1, 0
	        movf BARGB0, 0, 0
	        subwfb REMB0, 1, 0

			;// AARG++; Note that since we shifted AARG above, we can add
			;//         one simply by setting the least significant bit!
            ;//         Use the incf operation to do this so that the carry
            ;//         flag is cleared. Thus, the carry flag will always be
            ;//         zero at the top of the loop.

			incf AARGB2, 1, 0
        ;//}

        _false2424:

        decfsz LOOPCOUNT, 1, 0  ;// if (--count != 0) then loop. Does not affect carry flag.
        bra loop2424
	RETURN
ENDIF


;********************************************************************************************
;********************************************************************************************
;
;	DIVISIONE 32/32 
;      (ROUTINE SPECIFICHE 18FXXX)
;
;	MAX: 938 CICLI
;********************************************************************************************
;********************************************************************************************
IFDEF FXD3232U_DEF
FXD3232U
    ;// REM = 0
    clrf REMB0, 0
    clrf REMB1, 0
    clrf REMB2, 0
    clrf REMB3, 0

    ;// INDF1 = 32
    movlw D'32'
    movwf LOOPCOUNT, 0

    ;// Clear the carry
    bcf STATUS, 0, 0

loop3232:

	;//AARG32 <<= 1; The carry is always clear at the top of the loop.
	rlcf AARGB3, 1, 0
	rlcf AARGB2, 1, 0
	rlcf AARGB1, 1, 0
	rlcf AARGB0, 1, 0

	;//REM32 = (REM32 << 1) | (AARG32 >> 32)
	rlcf REMB3, 1, 0
	rlcf REMB2, 1, 0
	rlcf REMB1, 1, 0
	rlcf REMB0, 1, 0
	
	;//if (PROD >= BARG32)
	movf BARGB3, 0, 0
	subwf REMB3, 0, 0
	movf BARGB2, 0, 0
	subwfb REMB2, 0, 0
	movf BARGB1, 0, 0
	subwfb REMB1, 0, 0
	movf BARGB0, 0, 0
	subwfb REMB0, 0, 0
	bnc _false3232
    ;//{
	    ;//REM32-= BARG32;
	    movf BARGB3, 0, 0
	    subwf REMB3, 1, 0
	    movf BARGB2, 0, 0
	    subwfb REMB2, 1, 0
	    movf BARGB1, 0, 0
	    subwfb REMB1, 1, 0
	    movf BARGB0, 0, 0
	    subwfb REMB0, 1, 0

	    ;//++AARG32; Since AARG32 was shift to the left above, we only need to set
        ;//          the lowest bit. Use incf so that the carry flag will also be cleared.
        ;//          Thus, the carry will always be clear at the top of the loop.
	    incf AARGB3, 1, 0
    ;//}
_false3232:

    decfsz LOOPCOUNT, 1, 0    ;// does not affect the carry bit
    bra loop3232
	RETURN
ENDIF  

;********************************************************************************************
;**********************************************************************************************
;********************************************************************************************
;
;
;	ADDIZIONE E SOTTRAZIONE A 16 BIT
;********************************************************************************************
;********************************************************************************************
;
;	USO:	CALL  ADD (SUB; SUB_B_A)
;
;	AARG + BARG --> AARG	(AARGB0 = MSB ...)
;
;	ADD - SUB
;       Timing:	6 clks	(Ritorno Compreso)
;       PM: 5            DM: 4

IFDEF	ADD_SUB_16_DEF		;

ADD	MOVF	BARGB1, W
	ADDWF	AARGB1
	MOVF	BARGB0, W
	ADDWFC	AARGB0
	RETURN

SUB	MOVF	BARGB1, W
	SUBWF	AARGB1
	MOVF	BARGB0, W
	SUBWFB	AARGB0
	RETURN

;	SUB_B_A
;       Max Timing:     7 clks	(Ritorno Compreso)
;       Min Timing:     7 clks
;       PM: 6            DM: 4
SUB_B_A	
	MOVF	BARGB1, W	; FACCIO BARGB0 - AARGB0 --> AARGB0
	BSF	_C		; AZZERO IL BORROW [NEG(C)]
	SUBFWB	AARGB1		;
	MOVF	BARGB0, W	;
	SUBFWB	AARGB0		;
	RETURN			;
ENDIF				;
;				;
;********************************************************************************************
;********************************************************************************************
;
;	ADDIZIONE E SOTTRAZIONE A 24 BIT
;
;********************************************************************************************
;********************************************************************************************
;
;	USO:	CALL  ADD_24 (SUB_24; SUB_B_A_24)
;
;	AARG + BARG --> AARG
;	ADD_24 - SUB_24
;       Max Timing:     8 clks	(Ritorno Compreso)
;       Min Timing:     8 clks
;       PM: 7            DM: 6

IFDEF	ADD_SUB_24_DEF		;

ADD_24	MOVF	BARGB2, W
	ADDWF	AARGB2
	MOVF	BARGB1, W
	ADDWFC	AARGB1
	MOVF	BARGB0, W
	ADDWFC	AARGB0
	RETURN

SUB_24	MOVF	BARGB2, W
	SUBWF	AARGB2
	MOVF	BARGB1, W
	SUBWFB	AARGB1
	MOVF	BARGB0, W
	SUBWFB	AARGB0
	RETURN

;	SUB_B_A
;       Max Timing:     9 clks	(Ritorno Compreso)
;       Min Timing:     9 clks
;       PM: 8            DM: 4
SUB_24_B_A	
	MOVF	BARGB2, W	; FACCIO BARGB0 - AARGB0 --> AARGB0
	BSF	_C		; AZZERO IL BORROW [NEG(C)]
	SUBFWB	AARGB2		;
	MOVF	BARGB1, W	;
	SUBFWB	AARGB1		;
	MOVF	BARGB0, W	;
	SUBFWB	AARGB0		;
	RETURN			;
ENDIF				;
;				;
;********************************************************************************************
;********************************************************************************************
;
;	ADDIZIONE E SOTTRAZIONE A 32 BIT
;
;********************************************************************************************
;********************************************************************************************
;
;	USO:	CALL  ADD_32 (SUB_32; SUB_B_A_32)
;
;	AARG + BARG --> AARG
;	ADD_32 - SUB_32
;       Max Timing:     10 clks	(Ritorno Compreso)
;       Min Timing:     10 clks
;       PM: 9            DM: 8

IFDEF	ADD_SUB_32_DEF		;

ADD_32	MOVF	BARGB3, W
	ADDWF	AARGB3
	MOVF	BARGB2, W
	ADDWFC	AARGB2
	MOVF	BARGB1, W
	ADDWFC	AARGB1
	MOVF	BARGB0, W
	ADDWFC	AARGB0
	RETURN

SUB_32	MOVF	BARGB3, W
	SUBWF	AARGB3
	MOVF	BARGB2, W
	SUBWFB	AARGB2
	MOVF	BARGB1, W
	SUBWFB	AARGB1
	MOVF	BARGB0, W
	SUBWFB	AARGB0
	RETURN

;	SUB_B_A
;       Max Timing:     11 clks	(Ritorno Compreso)
;       Min Timing:     11 clks
;       PM: 10            DM: 4
SUB_32_B_A	
	MOVF	BARGB3, W	; FACCIO BARGB0 - AARGB0 --> AARGB0
	BSF	_C		; AZZERO IL BORROW [NEG(C)]
	SUBFWB	AARGB3		;
	MOVF	BARGB2, W	;
	SUBFWB	AARGB2		;
	MOVF	BARGB1, W	;
	SUBWFB	AARGB1		;
	MOVF	BARGB0, W	;
	SUBFWB	AARGB0		;
	RETURN			;
ENDIF				;
;				;
;**********************************************************************************************
;**********************************************************************************************
;**********************************************************************************************


;**********************************************************************************************
;**********************************************************************************************
;**********************************************************************************************
; ROUTINE PER EFFETTUARE ADDIZIONI E SOTTRAZIONI ALGEBRICHE
; I SEGNO DEVE ESSERE IN "SEGNO, A_SGN"	& "SEGNO, B_SGN"
;	
;******	16 BIT
;
;	S_SUB = S_ADD + 3 instructions
;       Max Timing:     .../... clks (S_ADD/A_SUB) (Ritorno Compreso)
;       Min Timing:     .../... clks (S_ADD/A_SUB)
;       PM: 38            DM: 5

IFDEF	AGEBRIC_SUM_16_DEF

S_SUB	BTG	SEGNO, B_SGN	; TOGGLE DI SEGNO, B_SGN

S_ADD	BCF	OVERFLOW	;

	BTFSC	SEGNO, A_SGN	; SELEZIONE DEI CASI POSSIBILI PER GLI ARGOMENTI A & B
	GOTO	AP		;
AN	BTFSC	SEGNO, B_SGN	;
	GOTO	AN_BP		; ---> -A +B
	GOTO	AN_BN		; ---> -A -B
AP	BTFSC	SEGNO, B_SGN	;
	GOTO	AP_BP		; ---> +A +B
	GOTO	AP_BN		; ---> +A -B


AP_BP				; +A +B
	CALL	ADD		;;;
	BSF	SEGNO, A_SGN	;	RISULTATO POSITIVO
	BTFSC	_C		;
	BSF	OVERFLOW	; SE C'E' CARRY SETTO IL BIT DI OVERFLOW
	RETURN			;
AN_BN				; -A -B	
	CALL	ADD		;;;
	BCF	SEGNO, A_SGN	;	RISULTATO NEGATIVO
	BTFSC	_C		;
	BSF	OVERFLOW	; SE C'E' CARRY SETTO IL BIT DI OVERFLOW
	RETURN			;

AP_BN	CALL	SUB		;;;	+A -B
	GOTO	DWN		;
AN_BP	CALL	SUB_B_A		;;;	-A +B
DWN	BTFSS	_C		;	METTO IL SEGNO GIUSTO AL RISULTATO
	BCF	SEGNO, A_SGN	;
	BTFSC	_C		;
	BSF	SEGNO, A_SGN	; 
	BCF	OVERFLOW	; SE SONO QUI SICURAMENTE NON SONO IN OVERFLOW
	BTFSC	_C		; SE IL RISULTATO E' POSITIVO ESCO E EVITO IL COMPLEMENTO A 2
	RETURN			;
				; COMPLEMENTO A 2 PER OTTENERE IL VALORE ASSOLUTO 
	MOVFF	AARGB0, BARGB0	; DEL NUMERO NEGATIVO ...
	MOVFF	AARGB1, BARGB1	; SI FA FACENDO (0x000000 - NEG_VALUE) 
	CLRF	AARGB0		;
	CLRF	AARGB1		;
	CALL	SUB		;;;
	RETURN			;
ENDIF

;******	24 BIT
;	
;	S_SUB = S_ADD + 3 instructions
;       Max Timing:     .../... clks (S_ADD/A_SUB) (Ritorno Compreso)
;       Min Timing:     .../... clks (S_ADD/A_SUB)
;       PM: 40            DM: 7

IFDEF	AGEBRIC_SUM_24_DEF

S_SUB_24
	BTG	SEGNO, B_SGN	; TOGGLE DI SEGNO, B_SGNS_ADD_24
S_ADD_24
	BCF	OVERFLOW	;

	BTFSC	SEGNO, A_SGN	; SELEZIONE DEI CASI POSSIBILI PER GLI ARGOMENTI A & B
	GOTO	AP24		;
AN24	BTFSC	SEGNO, B_SGN	;
	GOTO	AN_BP24		; ---> -A +B
	GOTO	AN_BN24		; ---> -A -B
AP24	BTFSC	SEGNO, B_SGN	;
	GOTO	AP_BP24		; ---> +A +B
	GOTO	AP_BN24		; ---> +A -B


AP_BP24				; +A +B
	CALL	ADD_24		;;;
	BSF	SEGNO, A_SGN	;	RISULTATO POSITIVO
	BTFSC	_C		;
	BSF	OVERFLOW	; SE C'E' CARRY SETTO IL BIT DI OVERFLOW
	RETURN			;
AN_BN24				; -A -B	
	CALL	ADD_24		;;;
	BCF	SEGNO, A_SGN	;	RISULTATO NEGATIVO
	BTFSC	_C		;
	BSF	OVERFLOW	; SE C'E' CARRY SETTO IL BIT DI OVERFLOW
	RETURN			;

AP_BN24	CALL	SUB_24		;;;	+A -B
	GOTO	DWN24		;
AN_BP24	CALL	SUB_24_B_A	;;;	-A +B
DWN24	BTFSS	_C		;	METTO IL SEGNO GIUSTO AL RISULTATO
	BCF	SEGNO, A_SGN	;
	BTFSC	_C		;
	BSF	SEGNO, A_SGN	; 
	BCF	OVERFLOW	; SE SONO QUI SICURAMENTE NON SONO IN OVERFLOW
	BTFSC	_C		; SE IL RISULTATO E' POSITIVO ESCO E EVITO IL COMPLEMENTO A 2
	RETURN			;
				; COMPLEMENTO A 2 PER OTTENERE IL VALORE ASSOLUTO 
	MOVFF	AARGB0, BARGB0	; DEL NUMERO NEGATIVO ...
	MOVFF	AARGB1, BARGB1	; SI FA FACENDO (0x000000 - NEG_VALUE) 
	MOVFF	AARGB2, BARGB2	; A SECONDA DEI BYTE CHE MI SERVONO SOSTITUISCO
	CLRF	AARGB0		;
	CLRF	AARGB1		;
	CLRF	AARGB2		;
	CALL	SUB_24		;;;
	RETURN			;
ENDIF
	
;******	32 BIT
;
;	S_SUB = S_ADD + 3 instructions
;       Max Timing:     .../... clks (S_ADD/A_SUB) (Ritorno Compreso)
;       Min Timing:     .../... clks (S_ADD/A_SUB)
;       PM: 42            DM: 9

IFDEF	AGEBRIC_SUM_32_DEF

S_SUB_32
	BTG	SEGNO, B_SGN	; TOGGLE DI SEGNO, B_SGN
S_ADD_32
	BCF	OVERFLOW	;

	BTFSC	SEGNO, A_SGN	; SELEZIONE DEI CASI POSSIBILI PER GLI ARGOMENTI A & B
	GOTO	AP32		;
AN32	BTFSC	SEGNO, B_SGN	;
	GOTO	AN_BP32		; ---> -A +B
	GOTO	AN_BN32		; ---> -A -B
AP32	BTFSC	SEGNO, B_SGN	;
	GOTO	AP_BP32		; ---> +A +B
	GOTO	AP_BN32 	; ---> +A -B


AP_BP32				; +A +B
	CALL	ADD_32		;;;
	BSF	SEGNO, A_SGN	;	RISULTATO POSITIVO
	BTFSC	_C		;
	BSF	OVERFLOW	; SE C'E' CARRY SETTO IL BIT DI OVERFLOW
	RETURN			;
AN_BN32				; -A -B	
	CALL	ADD_32		;;;
	BCF	SEGNO, A_SGN	;	RISULTATO NEGATIVO
	BTFSC	_C		;
	BSF	OVERFLOW	; SE C'E' CARRY SETTO IL BIT DI OVERFLOW
	RETURN			;

AP_BN32	CALL	SUB_32		;;;	+A -B
	GOTO	DWN32		;
AN_BP32	CALL	SUB_32_B_A	;;;	-A +B
DWN32	BTFSS	_C		;	METTO IL SEGNO GIUSTO AL RISULTATO
	BCF	SEGNO, A_SGN	;
	BTFSC	_C		;
	BSF	SEGNO, A_SGN	; 
	BCF	OVERFLOW	; SE SONO QUI SICURAMENTE NON SONO IN OVERFLOW
	BTFSC	_C		; SE IL RISULTATO E' POSITIVO ESCO E EVITO IL COMPLEMENTO A 2
	RETURN			;
				; COMPLEMENTO A 2 PER OTTENERE IL VALORE ASSOLUTO 
	MOVFF	AARGB0, BARGB0	; DEL NUMERO NEGATIVO ...
	MOVFF	AARGB1, BARGB1	; SI FA FACENDO (0x000000 - NEG_VALUE) 
	MOVFF	AARGB2, BARGB2	; A SECONDA DEI BYTE CHE MI SERVONO SOSTITUISCO
	MOVFF	AARGB3, BARGB3	; ADD E SUB CON ADD_24/32 E SUB_24/32 ... 
	CLRF	AARGB0		;
	CLRF	AARGB1		;
	CLRF	AARGB2		;
	CLRF	AARGB3		;
	CALL	SUB_32		;;;
	RETURN			;
ENDIF				;
;				;	
;**********************************************************************************************
;**********************************************************************************************
;**********************************************************************************************


;********************************************************************************************
;********************************************************************************************
;
;	CONVERSIONE BINARIO 16 BIT IN DECIMALE A 5 CIFRE
;********************************************************************************************
;********************************************************************************************
;
;	AARG B0/B1 ----->  UNIT, DEC, CENT, MIGL, DECMIGL
;	(SE INFERIORE A 5 ALLORA DEVO METTERE IL NUMERO IN )

IFDEF	DECIMAL_DECODE_5CIF_DEF	;

DECIMAL_DECODE_5CIF		;

	MOVLW	0x27		;	0x2710 = 10.000
	MOVWF	BARGB0		;
	MOVLW	0x10		;
	MOVWF	BARGB1		;
	CALL	FXD1616U	;
	MOVFF	AARGB1, DECMIGL	;
	MOVFF	REMB0, AARGB0	;
	MOVFF	REMB1, AARGB1	;

DECIMAL_DECODE_4CIF

	MOVLW	0x03		;	0x03E8 = 1.000
	MOVWF	BARGB0		;
	MOVLW	0xE8		;
	MOVWF	BARGB1		;
	CALL	FXD1616U	;
	MOVFF	AARGB1, MIGL	;
	MOVFF	REMB0, AARGB0	;
	MOVFF	REMB1, AARGB1	;

DECIMAL_DECODE_3CIF

	CLRF	BARGB0		;	0x64 = 100
	MOVLW	0x64		;
	MOVWF	BARGB1		;
	CALL	FXD1616U 	;
	MOVFF	AARGB1, CENT	;
	CLRF	REMB0		;
	MOVFF	REMB1, AARGB1	;

DECIMAL_DECODE_2CIF

	CLRF	BARGB0		;	0x0A = 10
	MOVLW	0x0A		;
	MOVWF	BARGB1		;
	CALL	FXD1616U	;
	MOVFF	AARGB1, DEC	;
	MOVFF	REMB1, UNIT	;

	RETURN
ENDIF
;********************************************************************************************
;
; ROUTINES PER LA CONVERSIONE DI UN SOLO BYTE
;

IFDEF	DECIMAL_DECODE_BYTE_DEF	;

DECIMAL_DECODE_BYTE

	MOVLW	0x64		;	0x64 = 100
	MOVWF	BARGB0		;
	CALL	FXD0808U	;
	MOVFF	AARGB0, CENT	;
	MOVFF	REMB0, AARGB0	;
	
DECIMAL_DECODE_BYTE_SHORT

	MOVLW	0x0A		;	0x0A = 10
	MOVWF	BARGB0		;
	CALL	FXD0808U	;
	MOVFF	AARGB0, DEC	;
	MOVFF	REMB0, UNIT	;

	RETURN
ENDIF
;
;********************************************************************************************
;********************************************************************************************
;********************************************************************************************

