;************************************************************************************
;
;	MODULO PER IL CONTROLLO DELL'ADC INTERNO DEL MICRO
;	ROUTINE SPECIFICHE PER PIC18fxxx
;	VERSIONE 1.1	02/01/2004
;
;	Le routine da chiamare sono:
;	--> INIT_ADC_INT (Inizializzazione BUS)
;	--> ACQUISIZIONE (Il risultato  in AN_H, AN_L, giustificato a destra)
;
;************************************************************************************


;**********************************************
; DEFINIRE NEL MASTER LE SEGUENTI LOCAZIONI ... 
;
; TEMP_adc, AN_H, AN_L, CHANNEL
; RICHIESTO FILE DI MACRO


#DEFINE		EXP_MED	.2		; NUM_MEDIA = 2^EXP_MEDIA; EXP_MEDIA E' COMPRESO 
					; NEL RANGE 0-5 (1-32 ACQUISIZIONI)

#UNDEFINE	Only8bit		; SE E' DEFINITO "Only8bit" IL RISULTATO SARA' SU AN_L 
					; NOTA: IL RISULATO DEVE ESSERE R JUSTIFIED!

#DEFINE		ACQTime	D'10'		; TEMPO DI ACQUISIZIONE IN us	

					; NOTA BENE: NUM_MEDIA = 2^EXP_MEDIA !
;---------------------------------------; EXP_MEDIA E' COMPRESO NEL RANGE 0-5 
IF EXP_MED == D'0'			; (1-64 ACQUISIZIONI)
	#DEFINE NUM_MED		D'1'	;
ENDIF					;
IF EXP_MED == D'1'			;
	#DEFINE NUM_MED		D'2'	;
ENDIF					;
IF EXP_MED == D'2'			;
	#DEFINE NUM_MED		D'4'	;
ENDIF					;
IF EXP_MED == D'3'			;
	#DEFINE NUM_MED		D'8'	;
ENDIF					;
IF EXP_MED == D'4'			;
	#DEFINE NUM_MED		D'16'	;
ENDIF					;
IF EXP_MED == D'5'			;
	#DEFINE NUM_MED		D'32'	;
ENDIF					;
IF EXP_MED == D'6'			;
	#DEFINE NUM_MED		D'64'	;
ENDIF					;
;---------------------------------------;


	;-----------------------;;
	; ADC SETTING		;;
	;-----------------------;;
INIT_ADC_INT			;;
	MOVLW   B'11000100'	;; SETTING PORTE An & Dig: RA0 = An, RA1 = An, RA3 = An, OTHER = Dig; R justified; 64Tosc
	MOVWF   ADCON1  	;;
	MOVLW	B'10000000'	;; INIZIALIZZAZIONE A/D: 64 Tosc, Channel 0, A/D MODULE OFF
	MOVWF	ADCON0		;;
	BSF	ADCON0, 0	;; A/D MODULE ON
	RETURN			;;
	;-----------------------;;


;-----------------------------------------------;;
;         ROUTINE DI ACQUISIZIONE		;;
;   	fino a 64 conversioni E FA LA MEDIA	;;
;      IL NUMERO DEL CANALE E' IN "CHANNEL"	;;
;-----------------------------------------------;;
						;
ACQUIRE						;
;	BSF	ADCON0, 0			;; A/D MODULE ON
;	DelayMicroSec	D'5'			;
	MOVLW	B'11000111'			;
	ANDWF	ADCON0, F			;
	MOVLW	B'00000111'			; SETTO IL CANALE GIUSTO!
	ANDWF	CHANNEL, W			;
	RLNCF	WREG, F				;
	RLNCF	WREG, F				;
	RLNCF	WREG, F				;
	IORWF	ADCON0, F			;
						;
	DelayMicroSec	ACQTime			; TEMPO DI SETTING
						;
	CLRF	AN_H				;
	CLRF	AN_L				;
	MOVLW	NUM_MED				; Routine di Acquisizione 
	MOVWF	TEMP_adc			; 
MEDIAT_LOOP					;
	CALL	CONV_ADC			;
	DECFSZ	TEMP_adc			;
	BRA	MEDIAT_LOOP			;
	CALL	CALC_MED			; A QUESTO PUNTO HO EFFETTUATO "NUM_MEDIA" ACQUISIZIONI, LA MEDIA DEI VALORI ...	
						; ... E' IN "AN_H/L"
;	BCF	ADCON0, 0			;
	RETURN					;
;						;
;-----------------------------------------------;
;-----------------------------------------------;
						;
CONV_ADC					;
	BSF	ADCON0, 2			; start
IOP	BTFSC	ADCON0, 2			;
	BRA	IOP				;
	MOVF	ADRESL, W			;
	ADDWF	AN_L, F				;
	MOVF	ADRESH, W			;
	ADDWFC	AN_H, F				;
	RETURN					;
;						;
;-----------------------------------------------;

;---------------------------------------;
; ROUTINE CHE FA LA MEDIA CON		;
; IL VALORE DI AN0_X (FINO A 64 VOLTE)	;
;---------------------------------------;
;---------------------------------------;
CALC_MED				;
IFDEF	Only8bit			;
	BCF	_C			; RIPORTO AD 8 BIT
	RRF	AN_H, F			;
	RRF	AN_L, F			;
	BCF	_C			;
	RRF	AN_H, F			;
	RRF	AN_L, F			;
ENDIF					;
	MOVLW	EXP_MED			;
	MOVWF	TEMP_adc		;
XXX_LOOP				;
	BCF	_C			; MEDIA SULL'ACQUISIZIONE 
	RRF	AN_H, F			;
	RRF	AN_L, F			;
	DECFSZ	TEMP_adc		;
	BRA	XXX_LOOP		;
	RETURN				;
;---------------------------------------;
