;***************************************************************************
;
; QUI SONO RACCOLTE TUTTE (O QUASI) LE ROUTINE DI SETTING DELLE PERIFERICHE
; DEI PIC 18FXXX ... 
; PER UTILIZZARLE BISOGNA 	INCLUDERE IL FILE ALL'INIZIO (PRIMA DI USARE LA MACRO)
; 				SETTARE LE PERIFERICHE DI INTERESSE
;				CANCELLARE QUELLE CHE NON INTERESSANO
;				CHIAMARE LA MACRO DEV_SETTING
;
;***************************************************************************

DEV_SETTING	MACRO	

	;*******************************;;
	; RS232 SETTING			;;
	;*******************************;;
	#DEFINE BoudRate       D'115200';;
	variable TRUEBoudRate		;;
	variable NUMBR			;;
	;---------------------------------------------------------------;;
	NUMBR = (FREQUENCY * D'1000' / BoudRate  / D'16') - 1		;;
	TRUEBoudRate = (FREQUENCY * D'1000') / (D'16' * (NUMBR + 1))	;;
	;---------------------------------------------------------------;;
if NUMBR > 255 
	ERROR "Velocit troppo bassa per la frequenza impostata!"
endif
	MOVLW	NUMBR		;;
        MOVWF   SPBRG       	;; SETTAGGIO REGISTRO BAUD RATE
	bcf	TRISC, 6	;; Setto I/O per la seriale
	bsf	TRISC, 7	;; 
        MOVLW   B'00100100' 	;;
        MOVWF   TXSTA       	;; SETTING REG TRASMISSIONE (8bit, no parity)
	BSF     INTCON, PEIE    ;; ATTIVO INTERRUPT PERIFERICI
 							;;
	MOVLW   B'00010000'     ;;
	MOVWF   RCSTA           ;; setting PARAMETRI di ricezione (Continous RX, ...)	
	BSF     RCSTA,SPEN      ;; RX/TX MODULE NOT YET ACTIVED
	CLRF    RCREG		;;
	BSF	PIE1, RCIE	;; interrupt di arrivo byte seriale
	;***********************;;



	;*******************************;;
	; COMPARE (1) SETTING 		;; MODULE COMPARE CHE MI RICHIAMA UN INTERRUPT OGNI 100 ms (A 16 MHz)
	;*******************************;;
	#DEFINE CMP_INTERVAL	D'1'	;; IN  Decimi di millisecondo! IL PRESCALER DEVE ESSERE FISSATO A 8!
	variable Real_CMP_INT		;; IN microsecondi!
	variable CMP_HL			;;
	variable CMP_L			;;
	variable CMP_H			;;
	;---------------------------------------------------------------;;
	CMP_HL = (CMP_INTERVAL * FREQUENCY) / (D'4' * D'8'* D'10')	;;
	Real_CMP_INT = (CMP_HL * D'4' * D'8' * D'1000') / FREQUENCY	;;
	CMP_L	= low CMP_HL						;;
	CMP_H	= high CMP_HL						;;
	CMP_U	= upper CMP_HL						;;
	;---------------------------------------------------------------;;
if CMP_U > 0 
	ERROR "Intervallo troppo lungo per la frequenza impostata!"
endif
	MOVLW	B'01111000'	;; Two 8bit operation, T3 Clk for CCP2, Presc. 1:8, Internal Clock
	MOVWF	T3CON		;; TIMER3 ALL'INIZIO  SPENTO !!!!!!!! 
				;;
	MOVLW	CMP_L		;; Setto il compare 
	MOVWF	CCPR1L		;;
	MOVLW	CMP_H		;;
	MOVWF	CCPR1H		;;
				;;
	MOVLW	B'00001011'	;; Compare Mode Setting: Trigger special event (reset timer, int, A/D start)
	MOVWF	CCP1CON		;; 
				;;
	BCF	PIR1, CCP1IF	;;
;	BSF	PIE1, CCP1IE	;; SETTING INTERRUPT
;	BSF	T3CON, TMR3ON	;; START TIMER3
	;***********************;;
	;***********************;;


	;***********************;;
	; PWM SETTING (2)	;;
	;***********************;;
        BCF     TRISC,1         ;; SETTATO PIN PWM2
        MOVLW   0xFF		;;
        MOVWF   PR2		;; SETTING PERIODO PWM
        MOVLW   B'00000100'     ;; SELECTED PRESCALER (1) TMR2 AND ENABLED 
        MOVWF   T2CON           ;;
        MOVLW   B'00001100'     ;; PWM2 ACTIVED
	MOVWF   CCP2CON         ;;
	CLRF	CCP2CON         ;; PWM2 DEACTIVATED
	CLRF	CCPR2L		;; DUTY CICLE (HIGH 8 BIT)
	BCF	PORTC, 1	;; PWM PIN OUTPUT LOW
IFDEF	IvertPWM		;;
	SETF	CCPR2L		;; DUTY CICLE (HIGH 8 BIT)
	BSF	PORTC, 1	;; PWM PIN OUTPUT LOW
ENDIF				;;
	;***********************;;

ENDM

