;--------------------------------------------------------------------
;
;	Srain Gauge Measurement Setup
;	08 - 06 - 2004		V 1.4
;
;--------------------------------------------------------------------

 	LIST P = 18F252
	include <p18f252.inc>

	#define FREQUENCY D'40000'	; Frequenza del procesore in KHz (va considerato anche l'eventuale PLL)

	include "18fXX2_conf.h"

CBLOCK 0x20

        TEMP, TEMP1, TEMP2, TEMP3, DELAY, TS, DELAY1, WAIT
	STATUS_TEMP, W_TEMP, BSR_TEMP
	CH_0_H, CH_0_L, CH_1_H, CH_1_L, CH_2_H, CH_2_L
	TEMP_adc, AN_H, AN_L, CHANNEL
	TEMP_VIS, TEMP_VIS2
	TEMP_RS232
	START_FLAG
	UPDATING_RATE_TMP_L, UPDATING_RATE_L
	UPDATING_RATE_TMP_H, UPDATING_RATE_H
	NUM_STEP, ENABLE_TMP
	CHANNEL_ENABLE, PROGR_INDEX, CHKSUM
	WAVE_FORM, WAVE_INDEX, WAVE_PRSCL, WAVE_MUL, WAVE_VALUE, WAVE_COUNT 
ENDC




;       I/O ports
;------------------------------------------------------------
;       serial comms.   :       PORTC <7:6>
;	LED
;------------------------------------------------------------

#UNDEFINE	ASCII
#UNDEFINE	ECHO
#DEFINE 	IvertPWM

#DEFINE DEF_STEP_DELAY_L	D'100'	;
#DEFINE DEF_STEP_DELAY_H	D'0'	;

#DEFINE BIT_LED		0
#DEFINE PORT_LED	PORTB
#DEFINE TRIS_LED	TRISB
#DEFINE LED	PORT_LED, BIT_LED

#DEFINE BIT_TRIG	0
#DEFINE PORT_TRIG	PORTC
#DEFINE TRIS_TRIG	TRISC
#DEFINE TRIG	PORT_TRIG, BIT_TRIG

;	WAVE_FORM REGISTER DEFINITIONS
#DEFINE W_SQUARE	WAVE_FORM, 0	; SELECTED SQUARE WAVE
#DEFINE W_COS		WAVE_FORM, 1	; SELECTED COSINE WAVE
#DEFINE W_TRIANG	WAVE_FORM, 2	; SELECTED TRIANGLE WAVE
#DEFINE W_SAWTH		WAVE_FORM, 3	; SELECTED SAWTOOTH WAVE
;...
#DEFINE W_UPD_FLAG	WAVE_FORM, 7	; READY TO UPDATE ACTUATOR PWM!!!

	org 	0x00
	goto	main

        #include "18fmacro.asm"			; Va definito sempre per primo ...
        #include "18f_int.asm"			; ... questo subito dopo ...
        #include "18f_perf.asm"			; ... e poi questo!
	#include "18_Math.asm"			;
	#include "18f_InternalAD.asm"		;


main	clrwdt

        CALL    SETPORTS

	CLRF	START_FLAG
	MOVLW	DEF_STEP_DELAY_L
	MOVWF	UPDATING_RATE_L
	MOVWF	UPDATING_RATE_TMP_L
	MOVLW	DEF_STEP_DELAY_H
	MOVWF	UPDATING_RATE_H
	MOVWF	UPDATING_RATE_TMP_H
	CLRF	CHANNEL_ENABLE
	BSF	CHANNEL_ENABLE, 0	;<------------------------------
	BSF	CHANNEL_ENABLE, 1	;<------------------------------
	BSF	CHANNEL_ENABLE, 2	;<------------------------------
	CLRF	WAVE_FORM
	CLRF	WAVE_INDEX
	CLRF	WAVE_VALUE
	CLRF	WAVE_COUNT 
	CLRF	WAVE_PRSCL
	INCF	WAVE_PRSCL, F
	CLRF	WAVE_MUL
	INCF	WAVE_MUL, F

	BSF	LED
	DelayMilliSec D'500'
	BCF	LED
	DelayMilliSec D'500'
	BSF	LED

	DelayMilliSec D'100'
	BSF	INTCON, PEIE
	BSF	INTCON, GIE

	GOTO	MAINLOOP


;**************************************************************************

SETPORTS
	
        CLRF    INTCON          ;
        clrf    PORTA
        clrf    PORTB
        clrf    PORTC
        movlw   B'00111111'
        movwf   TRISA   	;       PORTA
        movlw   B'00000000'
        movwf   TRISB   	;       PORTB
        movlw   B'11111111'
        movwf   TRISC   	;       PORTC
 
	BCF	TRIS_LED, BIT_LED
	BCF	PORT_LED, BIT_LED
 
	BCF	TRIS_TRIG, BIT_TRIG
	BCF	PORT_TRIG, BIT_TRIG

        CLRF    PIE1            ;
        CLRF    PIE2            ;

	DEV_SETTING		;; CONFIGURAZIONE DELLE DEVICES
	CALL	INIT_ADC_INT	;;
	
        RETURN



;******************************************************************
;******************************************************************
;******************************************************************
;----------------------------------------------------------------------------


; TICKS DI MISURA (Scatta ogni ... ms)

TIMER_UPDATE				;
	BCF	PIR1, CCP1IF		;; CLEAR DEL FLAG DI INTERRUPT PER IL COMPARE

	DECF	UPDATING_RATE_TMP_L, F	;
	BTFSC	STATUS, C		; SE PASSO DA 0 -> 255 ALLORA DECREMENTO ANCHE IL BYTE ALTO
	RETURN				;
					;
	DECF	UPDATING_RATE_TMP_H, F	;
	BTFSC	STATUS, C		; SE PASSO DA 0 -> 255 ALLORA HO FINITO DI CONTARE ... (IN REALTA' HO CONTATO UNO IN PIU'!)
	RETURN				;
					;
	BSF	START_FLAG, 0		;
	INCF	PROGR_INDEX, F		; PROGRESSIVE INDEX
							; REINIZIALIZZAZIONE DI "UPDATING_RATE_TMP_H/L"
	MOVFF	UPDATING_RATE_H, UPDATING_RATE_TMP_H	; DEVO DECREMENTARE "UPDATING_RATE" DI 1 
	MOVFF	UPDATING_RATE_L, UPDATING_RATE_TMP_L	; ALTRIMENTI CONTO UNA VOLTA IN PIU'!!!!!!
	DECF	UPDATING_RATE_TMP_L, F			;
	BTFSS	STATUS, C				;
	DECF	UPDATING_RATE_TMP_H, F			;


	INCF	WAVE_INDEX, F		;
	MOVF	WAVE_INDEX, W		;
	SUBWF	WAVE_PRSCL, W		;
	BTFSS	STATUS, Z		; SE WAVE_INDEX = WAVE_PRSCL --> SETTO IL FLAG E RESETTO L'INDEX
	RETURN				;
	BSF	W_UPD_FLAG		;
	CLRF	WAVE_INDEX		;
	RETURN				;


MAINLOOP
	BTFSS	START_FLAG, 0
	GOTO	MAINLOOP

	BSF	TRIG			;;
	MICROSECONDI	D'10'		;;
	BCF	TRIG			;;	

	CLRF	CHANNEL			;; CANALE "0"
	BTFSC	CHANNEL_ENABLE, 0	;;
	CALL	ACQUIRE			;;
	BTFSC	CHANNEL_ENABLE, 0	;;
	MOVFF	AN_L, CH_0_L		;;
	MOVFF	AN_H, CH_0_H		;;
	
	
	MOVLF	0x01, CHANNEL		;; CANALE "1"
	BTFSC	CHANNEL_ENABLE, 1	;;
	CALL	ACQUIRE			;;
	BTFSC	CHANNEL_ENABLE, 1	;;
	MOVFF	AN_L, CH_1_L		;;
	MOVFF	AN_H, CH_1_H		;;


	MOVLF	0x02, CHANNEL		;; CANALE "2"
	BTFSC	CHANNEL_ENABLE, 2	;;
	CALL	ACQUIRE			;;
	BTFSC	CHANNEL_ENABLE, 2	;;
	MOVFF	AN_L, CH_2_L		;;
	MOVFF	AN_H, CH_2_H		;;

	BTFSC	W_UPD_FLAG		;; UPDATE OF ACTUATOR IF IS THE MOMENT!
	CALL	UPDATE_ACTUATOR		;;

;---------------------------------------;;
	CLRF	CHKSUM			;;
	MOVLW	PROGR_INDEX		;; PROGRESSIVE INDEX!
	CALL	RS232PUTCHAR		;;

	MOVF	CH_0_L, W		;;
	BTFSC	CHANNEL_ENABLE, 0	;;
	ADDWF	CHKSUM, F		;;
	BTFSC	CHANNEL_ENABLE, 0	;;
	CALL	RS232PUTCHAR		;;
	IFNDEF	Only8bit		;;
	MOVF	CH_0_H, W		;;
	BTFSC	CHANNEL_ENABLE, 0	;;
	ADDWF	CHKSUM, F		;;
	BTFSC	CHANNEL_ENABLE, 0	;;
	CALL	RS232PUTCHAR		;;
	ENDIF				;;
;---					;;
	MOVF	CH_1_L, W		;;
	BTFSC	CHANNEL_ENABLE, 1	;;
	ADDWF	CHKSUM, F		;;
	BTFSC	CHANNEL_ENABLE, 1	;;
	CALL	RS232PUTCHAR		;;
	IFNDEF	Only8bit		;;
	MOVF	CH_1_H, W		;;
	BTFSC	CHANNEL_ENABLE, 1	;;
	ADDWF	CHKSUM, F		;;
	BTFSC	CHANNEL_ENABLE, 1	;;
	CALL	RS232PUTCHAR		;;
	ENDIF				;;
;---					;;
	MOVF	CH_2_L, W		;;
	BTFSC	CHANNEL_ENABLE, 2	;;
	ADDWF	CHKSUM, F		;;
	BTFSC	CHANNEL_ENABLE, 2	;;
	CALL	RS232PUTCHAR		;;
	IFNDEF	Only8bit		;;
	MOVF	CH_2_H, W		;;
	BTFSC	CHANNEL_ENABLE, 2	;;
	ADDWF	CHKSUM, F		;;
	BTFSC	CHANNEL_ENABLE, 2	;;
	CALL	RS232PUTCHAR		;;
	ENDIF				;;

	COMF	CHKSUM, W		;; CHKSUM!
	CALL	RS232PUTCHAR		;;
;---------------------------------------;;

	BCF	START_FLAG, 0	;
	GOTO	MAINLOOP


;****************************************************************************
;
TIMER_ON				;
	CLRF	PROGR_INDEX		;
	CLRF	TMR1L			;
	CLRF	TMR1L			;
	BCF	PIR1, CCP1IF		;
	BSF	PIE1, CCP1IE		; SETTING INTERRUPT
	BSF	T3CON, TMR3ON		; START TIMER3
	RETURN

TIMER_OFF				;
	BCF	PIR1, CCP1IF		;
	BCF	PIE1, CCP1IE		; RESETTING INTERRUPT
	BCF	T3CON, TMR3ON		; STOP TIMER3
	BCF	PIR1, CCP1IF		;
	RETURN

SetTime
	BTFSS	PIR1, RCIF				;
	BRA	$-2					; ATTENDO IL BYTE ALTO DEL TIME DELAY
	MOVFF	RCREG, UPDATING_RATE_H			; 
	MOVFF	UPDATING_RATE_H, UPDATING_RATE_TMP_H	;
	NOP						;
	BTFSS	PIR1, RCIF				;
	BRA	$-2					; ATTENDO IL BYTE BASSO DEL TIME DELAY
	MOVFF	RCREG, UPDATING_RATE_L			; 
	MOVFF	UPDATING_RATE_L, UPDATING_RATE_TMP_L	;
	RETURN

;****************************************************************************
;

PWM_MAN					;;
	MOVF	WAVE_VALUE, W		;;
IFDEF	IvertPWM			;;
	SUBLW	0xFF			;;
ENDIF					;;
	MOVWF	CCPR2L			;; 

        MOVLW   B'00001100'     	;; PWM2 ACTIVED
	MOVWF   CCP2CON         	;;
	RETURN				;;

PWM_ON					;;
	CLRF	CCPR2L			;;
IFDEF	IvertPWM
	SETF	CCPR2L			;;
ENDIF
        MOVLW   B'00001100'     	;; PWM2 ACTIVED
	MOVWF   CCP2CON         	;;
	CLRF	WAVE_INDEX		;;
	RETURN				;;

PWM_OFF
	CLRF	CCPR2L			;;
IFDEF	IvertPWM
	SETF	CCPR2L			;;
ENDIF
	CLRF	CCP2CON         	;;
	BCF	PORTC, 1		;;
IFDEF	IvertPWM
	BSF	PORTC, 1		;;
ENDIF
	RETURN

SetPWM
	BTFSS	PIR1, RCIF		;
	BRA	$-2			; WAITING FOR PWM AMPLITUDE BYTE 
	MOVFF	RCREG, WAVE_VALUE	;
	
	BTFSS	PIR1, RCIF		;
	BRA	$-2			; WAITING FOR PRESCALER BYTE
	MOVFF	RCREG, WAVE_PRSCL	; (IN TIMER COMPARISON WITH WAVE_INDEX)

	BTFSS	PIR1, RCIF		;
	BRA	$-2			; WAITING FOR WAVE_MUL BYTE
	MOVFF	RCREG, WAVE_MUL		; MUL POINTER FOR TABs ...
	RETURN

;****************************************************************************
;
CHs_SELECT
	BTFSS	PIR1, RCIF	;
	BRA	$-2		; ATTENDO IL BYTE PER IL PWM
	MOVLW	B'00000111'
	ANDWF	RCREG, W	;
	MOVWF	CHANNEL_ENABLE	;
	RETURN


;****************************************************************************
;
UPDATE_ACTUATOR

_SQUARE	BTFSS	W_SQUARE
	BRA	_COS
	TabSetting	SQUARE_TABLE	; SQUARE CALCULATION
	BRA	END_SEL_ACT
_COS	BTFSS	W_COS		
	BRA	_TRIANG
	TabSetting	N_COS_TABLE	; COS CALCULATION
	BRA	END_SEL_ACT		;
_TRIANG	BTFSS	W_TRIANG		
	BRA	_SAWTH
	TabSetting	TRIANGLE_TABLE	; TRIANGLE CALCULATION
	BRA	END_SEL_ACT
_SAWTH	BTFSS	W_SAWTH
	RETURN
	TabSetting	SAWTOOTH_TABLE	; SAAWTOOTH CALCULATION

END_SEL_ACT
	MOVF	WAVE_COUNT, W		;
	MULWF	WAVE_MUL		;
	MOVF	PRODL, W		;
	AddTab				;
	TBLRD*				;
	MOVF	TABLAT, W		;
	MULWF	WAVE_VALUE		; AMPLITUDE MODULATION
	MOVF	PRODH, W		;
IFDEF	IvertPWM
	SUBLW	0xFF
ENDIF
	MOVWF	CCPR2L			;	
	BCF	W_UPD_FLAG		;	
	INCF	WAVE_COUNT, F		;INCREMENTO L'INDICE DI CONTEGGIO PER LA TABELLA
	RETURN

;****************************************************************************
;
;	CONVERTE LA CIFRA IN ASCII CORRISPONDENTE
;
;****************************************************************************
DIGIT
		MOVWF		TEMP_VIS		;
		TabSetting 	DIGIT_TAB		;
		MOVF		TEMP_VIS, W		;
		ANDLW		B'00001111'		;
		AddTab					;
		TBLRD*					;
		MOVF		TABLAT, W		;
		RETURN					;
DIGIT_TAB
		DB		"0123456789ABCDEF"	;


;***************************************************************
;***************************************************************
;
;	DECODIFICA ISTRUZIONI SERIALI
;
;***************************************************************
;***************************************************************

DECODE
        MOVF    RCREG, W        ;
        MOVWF   TEMP_RS232	;
        
IFDEF	ECHO			;
        MOVWF	TXREG		; ECHO!
ENDIF				;

	BCF	STATUS, Z	;
	MOVLW	"1"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	GOTO	TIMER_ON	; 

	BCF	STATUS, Z	;
	MOVLW	"0"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	GOTO	TIMER_OFF	; 

	BCF	STATUS, Z	;
	MOVLW	"T"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	GOTO	SetTime		; 

	BCF	STATUS, Z	;
	MOVLW	"P"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	GOTO	SetPWM		; 

	BCF	STATUS, Z	;
	MOVLW	"F"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	GOTO	PWM_OFF		; 

	BCF	STATUS, Z	;
	MOVLW	"O"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	GOTO	PWM_MAN		; 

	BCF	STATUS, Z	;
	MOVLW	"N"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	GOTO	PWM_ON		; 

	BCF	STATUS, Z	;
	MOVLW	"C"		;  
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	GOTO	CHs_SELECT	; 

	BCF	STATUS, Z	; RESET ATTUATORE
	MOVLW	"6"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	CLRF	WAVE_FORM	;

	BCF	STATUS, Z	;
	MOVLW	"2"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	BSF	W_SQUARE	; 
	BTFSC	STATUS, Z	;
	CLRF	WAVE_COUNT	;

	BCF	STATUS, Z	;
	MOVLW	"3"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	BSF	W_COS		; 
	BTFSC	STATUS, Z	;
	CLRF	WAVE_COUNT	;

	BCF	STATUS, Z	;
	MOVLW	"4"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	BSF	W_TRIANG	; 
	BTFSC	STATUS, Z	;
	CLRF	WAVE_COUNT	;

	BCF	STATUS, Z	;					
	MOVLW	"5"		; 
	SUBWF	TEMP_RS232, W	;
	BTFSC	STATUS, Z	;
	BSF	W_SAWTH		; 
	BTFSC	STATUS, Z	;
	CLRF	WAVE_COUNT	;

;	BCF	STATUS, Z	;
;	MOVLW	"2"		; 
;	SUBWF	TEMP_RS232, W	;
;	BTFSC	STATUS, Z	;
;	CALL	....		; 
	RETURN


RS232PUTCHAR
TXS	BTFSS	PIR1, TXIF		;
	BRA	TXS			;
	MOVWF	TXREG			;
	RETURN				;


#INCLUDE "WaveTabs.asm"


END

